/* includ react in this js file? or use separate js */
import React from 'react';
import ReactDOM from 'react-dom';
//import Header from './header'; 

var routeParams = function(){
    var a = window.location.search.replace('?','');
    var c = a.split('&');
    var returnArray = [];
    var objReturn = {};
    for(var i = 0; i < c.length; i++){
        returnArray.push({
            name:c[i].split('=')[0],
            value:c[i].split('=')[1]
        });
        Object.defineProperty(objReturn,c[i].split('=')[0].toString(), {            
            value: c[i].split('=')[1]
        });
    }
    return objReturn;
};

var headRender = function(){
	var svgHMTL = '<svg width="48px" height="48px" viewBox="0 0 48 48" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" style=""> <title>animate/icn-fail</title> <desc>Created with Sketch.</desc> <defs></defs> <g id="Symbols" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" stroke-linecap="round" stroke-linejoin="round"> <g id="animate/icn-fail" stroke-width="4"> <g id="x-circle" transform="translate(4.000000, 4.000000)"> <path id="Oval" stroke-opacity="0.868744339" stroke="#D50000" d="M0,20A20,20 0,1,1 40,20A20,20 0,1,1 0,20" class="TYxheaBX_0"></path> <path d="M26,14 L14,26" id="Shape" stroke="#D0021B" class="TYxheaBX_1"></path> <path d="M14,14 L26,26" id="Shape" stroke="#D0021B" class="TYxheaBX_2"></path> </g> </g> </g><style>.TYxheaBX_0{stroke-dasharray:126 128;stroke-dashoffset:127;animation:TYxheaBX_draw 779ms ease-out 0ms forwards;}.TYxheaBX_1{stroke-dasharray:17 19;stroke-dashoffset:18;animation:TYxheaBX_draw 110ms ease-out 779ms forwards;}.TYxheaBX_2{stroke-dasharray:17 19;stroke-dashoffset:18;animation:TYxheaBX_draw 110ms ease-out 889ms forwards;}@keyframes TYxheaBX_draw{100%{stroke-dashoffset:0;}}@keyframes TYxheaBX_fade{0%{stroke-opacity:1;}92.3076923076923%{stroke-opacity:1;}100%{stroke-opacity:0;}}</style></svg>';
	setTimeout(function(){
		$("#svg-animated").html(svgHMTL);
	},1000);
};


class BoxNodata extends React.Component {
    constructor(props){
        super(props);
    }
    renderContent(){
        return (
            <please-wait>
                <div class="please_wait_container text-center">
                    <div class="sk-fading-circle">
                        <div class="sk-circle1 sk-circle"></div>
                        <div class="sk-circle2 sk-circle"></div>
                        <div class="sk-circle3 sk-circle"></div>
                        <div class="sk-circle4 sk-circle"></div>
                        <div class="sk-circle5 sk-circle"></div>
                        <div class="sk-circle6 sk-circle"></div>
                        <div class="sk-circle7 sk-circle"></div>
                        <div class="sk-circle8 sk-circle"></div>
                        <div class="sk-circle9 sk-circle"></div>
                        <div class="sk-circle10 sk-circle"></div>
                        <div class="sk-circle11 sk-circle"></div>
                        <div class="sk-circle12 sk-circle"></div>
                    </div>
                </div>
            </please-wait>
        )
    }
    render(){
        return (
            <div class="text-center" style={{margin:this.props.margin}}>
                {this.renderContent()}
            </div>
        )
    }
}


class Boxcontainer extends React.Component {
    constructor(props){
        super(props);
        this.state = {
            value: null
        };
        this.backHome = this.backHome.bind(this);
        this.backCheckout = this.backCheckout.bind(this);
    }

    backHome(){
        window.location.href=GURL.base_url()+'?base_shop_name='+window.SHOP_NAME+'&redirect_source=checkout/fail';        
    }

    backCheckout(){
        var dataOrder = this.props.value;
        var buildPdata = function(orderProductArray){
            var r = [];
            for(var i = 0; i < orderProductArray.length; i++){
                if(orderProductArray[i].object_table_id == "202"){
                    var qty = orderProductArray[i].amount;
                    var pid = orderProductArray[i].object_id;                   
                    r.push(pid+'-'+qty);
                }
            }
            return r;
        };
        var pdata = buildPdata(dataOrder.order_cart_data.cart_row_array);
        if(pdata.length > 0){
            window.location.href=GURL.base_url()+'checkout?base_shop_name='+window.SHOP_NAME+'&redirect_source=checkout/fail&pdata='+pdata.join(',');
        }
    }

    render() {
        var orderData = this.props.value;
        var order_id = orderData.order_id;
        return (
            <div class="container" data-react-node="2.0">
                <div class="col-xs-12 col-sm-10 col-sm-offset-1 col-md-8 col-md-offset-2">                    
                    <div className="orderFailContainer">
                        <div className="header">
                            <div className="icon">
                                <img src="extensions/devsource/dev.payment/style/assets/pinicon/icn-orderfail.svg" height="40" />
                            </div>
                            <div className="text">
                                ORDER #{order_id}
                            </div>
                        </div>
                        <div className="body">
                            <p>
                                มีข้อผิดพลาดในการชำระเงินด้วยวิธีนี้ กรุณาทำรายการอีกครั้ง หรือถ้าต้องการความช่วยเหลือ สามารถแจ้งเจ้าหน้าที่ได้ตามช่องทางการติดต่อ
                            </p>
                            <div className="padding" size="20"></div>
                            <div className="buttonFallback">
                                <button onClick={this.backHome} className="btn-home">
                                    กลับหน้าแรก<br/>BACK HOME
                                </button>
                                <button onClick={this.backCheckout} className="btn-checkout">
                                    ทำรายการใหม่อีกครั้ง<br/>CHECKOUT AGAIN
                                </button>
                            </div>
                        </div>
                    </div>
                    <div className="padding" size="80"></div>
                </div>
            </div>
        )
    }
}

class PageLoading extends React.Component {
    render(){
        return (
            <div id="section-process" className="active">
                <div className="process-backdrop">
                    <BoxNodata margin="40vh 0px 0px 0px" />
                </div>
            </div>
        )
    }
}

class Bodyelement extends React.Component {
	constructor(props) {
        super(props);
        this.state = {
        	cart_data: false,
        	order_data: false,
        };
    }

    getOrderId(id, callback){
    	var dataSend = {
    		'txt_order_id':id
    	};
    	GAEAPI.get('order/id', dataSend).then(function(e){
    		callback(e);
    	});
    }

    doHeadRender(){
    	if(this.state.order_data !== false){
    		headRender();
            $('#pageLoading').hide();
    	}
    }

    componentDidMount() {
    	var t = this; 
        this.getOrderId(routeParams().order_id,(e)=>{
            var time = setTimeout(()=>{
                t.setState({order_data: e.data});
                t.doHeadRender();
                window.clearTimeout(time);
            }, 1500);
        });
    }

    renderContent(){
        if(!this.state.order_data){
            return (
                <div></div>
            )
        } else {
            return (
                <div>
                    <div className="padding" size="40"></div>
                    <Boxcontainer value={this.state.order_data} />
                </div>
            )
        }
    }

    render() {        
        return (            
            <div>
                {this.renderContent()}
            </div>
        )
    }

}

ReactDOM.render(
    <Bodyelement />,
    document.getElementById('root-fail-app')
);